#ifndef __CAMERA3D_H__
#define __CAMERA3D_H__

#include<stdio.h>
#include"vector3d.h"

class Camera3D {
  public:
      // Modo en que estamos
    bool    interactiva;
      // Camara interactiva
    float    angleA;    // Giro alrededor de las Y (radianes)
    float    angleB;    // Inclinacion del cabezon (radianes)
    float    velocity;  // Velocidad
    Vector3D position;  // Posicion del observador
    Vector3D incr;      // Incremento
    Vector3D prelookat; // parametro precalculado
      // Camara automatica
    float    rx;        // Angulo de giro (radianes)
    float    dist;      // Distancia de la camara al punto que miramos
    Vector3D lookat;    // centro alrededor del cual giramos
      // Parametros de la camara
    float    angle;     // Angulo de obertura de la camara
    float    znear;     // Plano de corte anterior
    float    zfar;      // Plano de corte anterior
    float    aspect;    // Aspect-Ratio
    float    zoom;      // Factor de zoom
    
      // Constructoras
    Camera3D();
    
      // Configuracion
    void setZnear(float zn);
    void setZfar(float zf);
    
      // Operaciones en OpenGL
    void SetupProjectionOpenGL(void);
    void SetupCameraOpenGL(void);
    
      // Navegacion de la camara
    void avanzar(bool palante = true);
    void setVel(float vel);
    void girar(float izqder = 0.0, float arrbaj = 0.0);
    void pan(bool paloslaos, bool inc);
    void setPosition(Vector3D pos);
    
      // Cargar/salvar camara
    void save(FILE *f);
    void load(FILE *f);
};

#endif
