#include<GL/glut.h>
#include"light3d.h"

Light3D::Light3D()
{
  ambient  = Color3D(0.4, 0.4, 0.4);
  diffuse  = Color3D(.8, .8, .8);
  specular = Color3D(.8, .8, .8);
  position = Vector3D(500, 500, 250);
}

void Light3D::InitLight(void)
{
  glEnable(GL_LIGHTING);
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambient.color);
  
  glLightfv(GL_LIGHT0, GL_DIFFUSE,  diffuse.color);
  glLightfv(GL_LIGHT0, GL_SPECULAR, specular.color);
  glEnable(GL_LIGHT0);
}

void Light3D::toOpenGL(void)
{
  glLightfv(GL_LIGHT0, GL_POSITION, position.vector);
}

// NOTA: La siguiente funcion, dada la ecuacin del plano de una cara, determina si esa luz
//       ilumina o no esa cara.
//       Es un intento de optimizacin que hize para las sombras, pero que no me convenci.
//       En mi opinion es que debi cometer algun error en los calculos. Cuestion de investigarlo
//       pero no he tenido tiempo

bool Light3D::visible(Vector3D &pq)
{
  return (((pq.X() * position.X() + pq.Y() * position.Y() + pq.Z() * position.Z() + pq.W()) >= 0) ? true : false);
}

void Light3D::save(FILE *f)
{
  ambient.save(f);
  diffuse.save(f);
  specular.save(f);
  position.save(f);
}

void Light3D::load(FILE *f)
{
  ambient.load(f);
  diffuse.load(f);
  specular.load(f);
  position.load(f);
}
