#ifndef __MATERIAL3D_H__
#define __MATERIAL3D_H__

#include<stdio.h>
#include"color3d.h"

class Material3D
{
  public:
    bool    initialized;
    bool    onlyColor;
    int     mirror;
    
    Color3D flatColor;
    
    Color3D ambient;
    Color3D diffuse;
    Color3D specular;
    bool    twoSided;
    float   shiny;
    float   alpha;
    
    Material3D(void);
    Material3D(const Material3D &m);
    Material3D(Color3D flc);
    Material3D(Color3D amb, Color3D diff, Color3D spec, bool twoS, float sh, float al);    
    Material3D(Color3D amb, Color3D diff, Color3D spec, bool twoS, float sh, float al, int mirr);

    void MakeMirror(int mirr);
    bool operator == (Material3D &m);
    
    void print(char *sep);
    
    void toOpenGL(void);
    
    void save(FILE *f);
    void load(FILE *f);
};

#endif
